;;; constants, variables


docon:
  dup_
  pop tosh
  pop tosl
  rcall ifetch
  ret


.set heap = $0060

;; tib

.dw link
.set link = pc - 1
.db 't','i','b',0

tib:
  rcall docon
  .dw heap
.set heap = heap + $80

;; >in

.dw link
.set link = pc - 1
.db '>','i','n',0

toin:
  rcall docon
  .dw heap
.set heap = heap + 2

;; link

.dw link
.set link = pc - 1
.db 'l','i','n','k',0

linkk:
  rcall docon
  .dw heap
.set heap = heap + 2

;; mlink

.dw link
.set link = pc - 1
.db 'm','l','i','n','k',0

mlinkk:
  rcall docon
  .dw heap
.set heap = heap + 2

;; dict

.dw link
.set link = pc - 1
.db 'd','i','c','t',0

dict:
  rcall docon
  .dw heap
.set heap = heap + 2

;; dp

.dw link
.set link = pc - 1
.db 'd','p',0

dp:
  rcall docon
  .dw heap
.set heap = heap + 2

;; idp

.dw link
.set link = pc - 1
.db 'i','d','p',0

idp:
  rcall docon
  .dw heap
.set heap = heap + 2

;; source

.dw link
.set link = pc - 1
.db 's','o','u','r','c','e',0

source:
  rcall docon
  .dw heap
.set heap = heap + 2

;; tasks

.dw link
.set link = pc - 1
.db 't','a','s','k','s',0

tasks:
  rcall docon
  .dw heap
.set heap = heap + 2


;;; interrupt revectors

;; 'int0

.dw link
.set link = pc - 1
.db '\'','i','n','t','0',0

int0:
  rcall docon
  .dw heap
.set heap = heap + 2

;; 'int1

.dw link
.set link = pc - 1
.db '\'','i','n','t','1',0

int1:
  rcall docon
  .dw heap
.set heap = heap + 2

;; 'timer2comp

.dw link
.set link = pc - 1
.db '\'','t','i','m','e','r','2','c','o','m','p',0

timer2comp:
  rcall docon
  .dw heap
.set heap = heap + 2

;; 'timer2ovf

.dw link
.set link = pc - 1
.db '\'','t','i','m','e','r','2','o','v','f',0

timer2ovf:
  rcall docon
  .dw heap
.set heap = heap + 2

;; 'timer1capt

.dw link
.set link = pc - 1
.db '\'','t','i','m','e','r','1','c','a','p','t',0

timer1capt:
  rcall docon
  .dw heap
.set heap = heap + 2

;; 'timer1compa

.dw link
.set link = pc - 1
.db '\'','t','i','m','e','r','1','c','o','m','p','a',0

timer1compa:
  rcall docon
  .dw heap
.set heap = heap + 2

;; 'timer1compb

.dw link
.set link = pc - 1
.db '\'','t','i','m','e','r','1','c','o','m','p','b',0

timer1compb:
  rcall docon
  .dw heap
.set heap = heap + 2

;; 'timer1ovf

.dw link
.set link = pc - 1
.db '\'','t','i','m','e','r','1','o','v','f',0

timer1ovf:
  rcall docon
  .dw heap
.set heap = heap + 2

;; 'timer0ovf

.dw link
.set link = pc - 1
.db '\'','t','i','m','e','r','0','o','v','f',0

timer0ovf:
  rcall docon
  .dw heap
.set heap = heap + 2

;; 'spistc

.dw link
.set link = pc - 1
.db '\'','s','p','i','s','t','c',0

spistc:
  rcall docon
  .dw heap
.set heap = heap + 2

;; 'usartrxc

.dw link
.set link = pc - 1
.db '\'','u','s','a','r','t','r','x','c',0

usartrxc:
  rcall docon
  .dw heap
.set heap = heap + 2

;; 'usartudre

.dw link
.set link = pc - 1
.db '\'','u','s','a','r','t','u','d','r','e',0

usartudre:
  rcall docon
  .dw heap
.set heap = heap + 2

;; 'usarttxc

.dw link
.set link = pc - 1
.db '\'','u','s','a','r','t','t','x','c',0

usarttxc:
  rcall docon
  .dw heap
.set heap = heap + 2

;; 'adc

.dw link
.set link = pc - 1
.db '\'','a','d','c',0

adcc:
  rcall docon
  .dw heap
.set heap = heap + 2

;; 'eerdy

.dw link
.set link = pc - 1
.db '\'','e','e','r','d','y',0

eerdy:
  rcall docon
  .dw heap
.set heap = heap + 2

;; 'anacomp

.dw link
.set link = pc - 1
.db '\'','a','n','a','c','o','m','p',0

anacomp:
  rcall anacomp
  .dw heap
.set heap = heap + 2

;; 'twi

.dw link
.set link = pc - 1
.db '\'','t','w','i',0

twi:
  rcall docon
  .dw heap
.set heap = heap + 2

;; 'spmrdy

.dw link
.set link = pc - 1
.db '\'','s','p','m','r','d','y',0

spmrdy:
  rcall docon
  .dw heap
.set heap = heap + 2

.set datamem = heap


;;; eeprom variables

.eseg
.dw datamem
.dw codemem
.dw lastword
.dw lastmacro
.cseg

.set eheap = 0

;; ~dp

.dw link
.set link = pc - 1
.db '~','d','p',0

tildedp:
  rcall docon
  .dw eheap
.set eheap = eheap + 2

;; ~idp

.dw link
.set link = pc - 1
.db '~','i','d','p',0

tildeidp:
  rcall docon
  .dw eheap
.set eheap = eheap + 2

;; ~link

.dw link
.set link = pc - 1
.db '~','l','i','n','k',0

tildelink:
  rcall docon
  .dw eheap
.set eheap = eheap + 2

;; ~mlink

.dw link
.set link = pc - 1
.db '~','m','l','i','n','k',0

tildemlink:
  rcall docon
  .dw eheap
.set eheap = eheap + 2

.set eemem = eheap


;;; constants

;; bl

.dw link
.set link = pc - 1
.db 'b','l',0

bl:
  rcall docon
  .dw ' '

