;; i!
;;
;; ( x a-addr -- )
;;
;; store cell to instruction memory

.dw link
.set link = pc - 1
.db 'i','!',0

istore:
  ; get pointer to flash
;  movw z,tos
;  lsl zl
;  rol zh
  lsl tosl
  rol tosh
  movw z,tos

  ; get data to write
  ld r0,y+
  ld r1,y+

  ; new TOS
;  drop_

  ; write data to temp page buffer
  ldi temp0,(1<<SPMEN)
  rcall dospm

  ; fill in the rest of the page
  rcall pageload

  ; erase page
  ldi temp0,(1<<PGERS|1<<SPMEN)
  rcall dospm

  ; write page
  ldi temp0,(1<<PGWRT|1<<SPMEN)
  rcall dospm

  ; reenable RWW section
  ldi temp0,(1<<RWWSRE|1<<SPMEN)
  rcall dospm

  ret


;; pageload
;;
;; copies a page of flash to
;; the temporary page buffer.
;; Z should contain any address
;; in the desired page.

pageload:
  ; get beginning of page
  andi zl,low(pagemask)
  andi zh,high(pagemask)

  ; loop counter (in words)
  ldi xl,low(pagesize)
  ldi xh,high(pagesize)
  adiw x,0

pageload_loop:
  breq pageload_done
  lpm r0,z+
  lpm r1,z+
  sbiw z,2

  ; don't copy the address we're trying
  ; to change.  each location in the
  ; temporary buffer can only be
  ; written once.
  cp zl,tosl
  cpc zh,tosh
  breq pageload_skip
  
  ldi temp0,(1<<SPMEN)
  rcall dospm

pageload_skip:
  adiw z,2
  sbiw x,1
  rjmp pageload_loop

pageload_done:
  ; reset z to start of page
;  subi zl,low(pagesize*2)
;  sbci zh,high(pagesize*2)
  movw z,tos
  andi zl,low(pagemask)
  andi zh,high(pagemask)
  drop_
  ret


;; dospm
;;
;; execute spm instruction
;;   temp0 holds the value for SPMCR

dospm:
  ; disable interrupts if enabled,
  ; store status register
  in temp1,SREG
  cli

  ; execute spm
  out SPMCR,temp0
  spm

dospm_wait:
  ; wait until done
  in temp2,SPMCR
  sbrc temp2,SPMEN
  rjmp dospm_wait

  ; restore status register
  out SREG,temp1
  ret

